import React from 'react';
import { TouchableWithoutFeedbackProps, StyleProp, ViewStyle, TextStyle, FlexStyle, ThemeAttributeBackgroundPropType, ViewProps } from 'react-native';
export interface LinearGradientProps extends ViewProps {
    colors?: (string | number)[];
    start?: {
        x: number;
        y: number;
    };
    end?: {
        x: number;
        y: number;
    };
    locations?: number[];
    useAngle?: boolean;
    angleCenter?: {
        x: number;
        y: number;
    };
    angle?: number;
}
declare type allStyle = FlexStyle | ViewStyle | TextStyle | undefined | null;
/**
 * @prop disabled 是否禁止点击
 */
export interface touchableProps extends TouchableWithoutFeedbackProps {
    activeOpacity?: number;
    containerStyle?: allStyle;
    disabledContainerStyle?: StyleProp<ViewStyle>;
    androidBackground?: ThemeAttributeBackgroundPropType;
    childGroupStyle?: StyleProp<ViewStyle>;
    children?: React.ReactNode;
    allowFontScaling?: boolean;
    type?: ButtonType;
    linearGradientStyle?: LinearGradientProps;
    fontStyle?: StyleProp<TextStyle>;
    fontDisabledStyle?: StyleProp<TextStyle>;
}
export declare type ButtonType = 'primary' | 'minor';
export default function Button(props: touchableProps): JSX.Element;
export {};
