import {
  BackgroundPropType,
  Platform,
  TouchableNativeFeedback,
  TouchableNativeFeedbackProps,
  TouchableOpacity,
  TouchableWithoutFeedbackProps
} from "react-native";
import React from "react";

interface TouchableContainerProps extends TouchableWithoutFeedbackProps, TouchableNativeFeedbackProps {
  // TouchableNativeFeedback  only effect TouchableOpacity android
  background?: BackgroundPropType;
  // TouchableNativeFeedback  only effect TouchableOpacity android
  useForeground?: boolean;
  // Animate the touchable to a new opacity. only effect TouchableOpacity iOS
  setOpacityTo?: (value: number) => void;
  children: React.ReactElement;
}

export function TouchableContainer(props: TouchableContainerProps) {
  if (Platform.OS === "android") {
    return <TouchableNativeFeedback {...props} />;
  } else {
    return <TouchableOpacity {...props} />;
  }
}
