import React, { Children } from 'react';

export default function coalesceNonElementChildren(
  children: React.ReactNode,
  coalesceNodes: (children: React.ReactNode, index: number) => React.ReactNode
) {
  const coalescedChildren = [];

  let contiguousNonElements: React.ReactNode[] = [];
  Children.forEach(children, child => {
    if (!React.isValidElement(child)) {
      contiguousNonElements.push(child);
      return;
    }

    if (contiguousNonElements.length) {
      coalescedChildren.push(coalesceNodes(contiguousNonElements, coalescedChildren.length));
      contiguousNonElements = [];
    }

    coalescedChildren.push(child);
  });

  if (contiguousNonElements.length) {
    coalescedChildren.push(coalesceNodes(contiguousNonElements, coalescedChildren.length));
  }

  return coalescedChildren;
}
