import React from 'react';
import { StyleSheet, Text } from 'react-native';
// @ts-ignore
import type { TextProps } from 'react-native/Libraries/Text/TextProps';

const H1 = (props?: TextProps) => {
  return <Text {...props} style={[styles.H1, props?.style]} />;
};

const H2 = (props?: TextProps) => {
  return <Text {...props} style={[styles.H2, props?.style]} />;
};

const H3 = (props?: TextProps) => {
  return <Text {...props} style={[styles.H3, props?.style]} />;
};

const H4 = (props?: TextProps) => {
  return <Text {...props} style={[styles.H4, props?.style]} />;
};

const H5 = (props?: TextProps) => {
  return <Text {...props} style={[styles.H5, props?.style]} />;
};

const H6 = (props?: TextProps) => {
  return <Text {...props} style={[styles.H6, props?.style]} />;
};

const Subtitle1 = (props?: TextProps) => {
  return <Text {...props} style={[styles.SubTitle1, props?.style]} />;
};

const Subtitle2 = (props?: TextProps) => {
  return <Text {...props} style={[styles.SubTitle2, props?.style]} />;
};

const Body1 = (props?: TextProps) => {
  return <Text {...props} style={[styles.Body1, props?.style]} />;
};

const Body2 = (props?: TextProps) => {
  return <Text {...props} style={[styles.Body2, props?.style]} />;
};

const ButtonText = (props?: TextProps) => {
  return <Text {...props} style={[styles.ButtonText, props?.style]} />;
};

const Caption = (props?: TextProps) => {
  return <Text {...props} style={[styles.Caption, props?.style]} />;
};

const Overline = (props?: TextProps) => {
  return <Text {...props} style={[styles.OverLine, props?.style]} />;
};

const styles = StyleSheet.create({
  H1: {
    fontSize: 96,
    color: '#333',
    fontWeight: '200',
    letterSpacing: -1.5
  },
  H2: {
    fontSize: 60,
    color: '#333',
    fontWeight: '200',
    letterSpacing: -0.5
  },
  H3: {
    fontSize: 48,
    color: '#333',
    letterSpacing: 0
  },
  H4: {
    fontSize: 34,
    color: '#333',
    letterSpacing: 0.25
  },
  H5: {
    fontSize: 24,
    color: '#333',
    letterSpacing: 0
  },
  H6: {
    fontSize: 20,
    color: '#333',
    fontWeight: '600',
    letterSpacing: 0.15
  },
  SubTitle1: {
    fontSize: 16,
    color: '#333',
    fontWeight: 'normal',
    letterSpacing: 0.15
  },
  SubTitle2: {
    fontSize: 14,
    color: '#333',
    fontWeight: 'bold',
    letterSpacing: 0.1
  },
  Body1: {
    fontSize: 16,
    color: '#333',
    fontWeight: 'normal',
    letterSpacing: 0.5
  },
  Body2: {
    fontSize: 14,
    color: '#333',
    fontWeight: 'normal',
    letterSpacing: 0.25
  },
  ButtonText: {
    fontSize: 14,
    color: '#333',
    fontWeight: 'bold',
    letterSpacing: 1.25
  },
  Caption: {
    fontSize: 12,
    color: '#333',
    fontWeight: 'normal',
    letterSpacing: 0.4
  },
  OverLine: {
    fontSize: 10,
    color: '#333',
    fontWeight: 'normal',
    letterSpacing: 1.5
  }
});

export { H1, H2, H3, H4, H5, H6, Subtitle1, Subtitle2, Body2, Body1, ButtonText, Caption, Overline };
